!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!! Automation of COSMO Model Runs                                   !!!
!!! READING OF "icon_new" FILE & SUBSEQUENTLY FOLLOWING TASKS ARE .. !!!
!!! ACCOMPLISHED:                                                    !!!
!!! (1) Extract the COSMO Model Initialization Time Stamp            !!!
!!! (2) Prepare the Forecast Time Stamps for affixing in GrADs       !!!
!!! (3) Generation of Output Folders (Including Month)               !!!      
!!! DBS (November 28, 2022)                 			     !!!
!!! Now name of the files are put up as D+1 (Previous Day -> Today)  !!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

        Character(len=100) :: ipf, opf, cyyyy, cmm, cdd, chh
        Character(len=3), Dimension(12)  :: cmon1, cmon2
	Integer, Dimension(17)	:: khh, khh2
              
        Data ipf /'/home/subbu/DBS-COSMO/GMEData/icon_new'/     
        Data opf /'/home/subbu/DBS-COSMO/GMEData/RUN-COSMO-MODEL'/

        Data cmon1  /'Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun',          &
                     'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'/      

        Data cmon2  /'jan', 'feb', 'mar', 'apr', 'may', 'jun',          &
                     'jul', 'aug', 'sep', 'oct', 'nov', 'dec'/      

	Data khh    /0, 6, 12, 18, 0, 6, 12, 18,                        &
		     0, 6, 12, 18, 0, 6, 12, 18, 0/

	Data imodel_option /1/

	Open (555, file='/home/subbu/DBS-COSMO/SHAR/NORMAL-SPINUP',     &
	           form='formatted')

	Read (555, *, err=1001,end=1001) imodel_option
 1001	Continue

        Open (11, file = ipf, form='formatted')
        Open (12, file = opf, form='formatted')

        Read (11, 10) cyyyy, cmm, cdd, chh
 10     Format (a4, 2a2, /, a2)        

        Read (cyyyy, *) iyyyy
        Read (cmm, *) imm
        Read (cdd, *) idd
        Read (chh, *) ihh     

	ikhh = (ihh/6)+1+1
	! ikhh (what should be the first +6h forecast time)

        Call cal_jul_cal (idd, imm, iyyyy, jday, 1)
        Call cal_jul_cal (31, 12, iyyyy, jdaylast, 1)

        jday1   = jday
        jday2   = jday + 1

        iyyyy1  = iyyyy
        iyyyy2  = iyyyy

        If (jday2 > jdaylast) iyyyy2 = iyyyy2 + 1
        If (jday2 > jdaylast) jday2 = 1 

        Call cal_jul_cal (idd1, imm1, iyyyy1, jday1, -1)
        Call cal_jul_cal (idd2, imm2, iyyyy2, jday2, -1)

	Write (12, 11)
 11	Format ('#!/bin/bash')
	Write (12, 12)
 12	Format (10x, 'cd ~/DBS-COSMO/GMEData', /,                           &
        10x, 'cp igfff00000000 ~/DBS-COSMO/Topography')
	Write (12, 13)
 13	Format (10x, 'cp ~/DBS-COSMO/SHAR/INPUT-F .')
	If (imodel_option==1) Write (12, 131)
	If (imodel_option==2) Write (12, 132)
 131	Format (10x, 'cp ~/DBS-COSMO/SHAR/INPUT.M INPUT')
 132	Format (10x, 'cp ~/DBS-COSMO/SHAR/INPUT.S INPUT')
	If (imodel_option==1) Write (12, 141)
	If (imodel_option==2) Write (12, 142)
 141	Format (10x, 'cp ~/DBS-COSMO/SHAR/INPUT_COSMO.M INPUT_COSMO')
 142	Format (10x, 'cp ~/DBS-COSMO/SHAR/INPUT_COSMO.S INPUT_COSMO')
	Write (12, 15)
 15	Format (10x, 'cp ~/DBS-COSMO/SHAR/MASTER.gs cosmo-grads.gs')

	Write (12, 16) 'YYY1', iyyyy1, ' INPUT'
	Write (12, 16) 'YYY2', iyyyy2, ' INPUT'
	Write (12, 16) 'YYY1', iyyyy1, ' INPUT-F'
	Write (12, 16) 'YYY2', iyyyy2, ' INPUT-F'
	Write (12, 16) 'YYY1', iyyyy1, ' INPUT_COSMO'
	Write (12, 16) 'YYY2', iyyyy2, ' INPUT_COSMO'
	Write (12, 16) 'YYY1', iyyyy1, ' cosmo-grads.gs'
	Write (12, 16) 'YYY2', iyyyy2, ' cosmo-grads.gs'
 16	Format (10x, 'replace-string ', a4, 1x, i4.4, a20)

	Write (12, 17) 'Mon', cmon1(imm1), ' INPUT'
	Write (12, 17) 'Mon', cmon1(imm1), ' INPUT-F'
	Write (12, 17) 'Mon', cmon1(imm1), ' INPUT_COSMO'
	Write (12, 17) 'Mon', cmon2(imm2), ' cosmo-grads.gs'
 17	Format (10x, 'replace-string ', a3, 1x, a3, a20)

	Write (12, 18) 'D1', idd1, ' INPUT'
	Write (12, 18) 'D1', idd1, ' INPUT-F'
	Write (12, 18) 'D1', idd1, ' INPUT_COSMO'
	Write (12, 18) 'D1', idd1, ' cosmo-grads.gs'

	Write (12, 18) 'D2', idd2, ' INPUT'
	Write (12, 18) 'D2', idd2, ' INPUT-F'
	Write (12, 18) 'D2', idd2, ' INPUT_COSMO'
	Write (12, 18) 'D2', idd2, ' cosmo-grads.gs'

	Write (12, 18) 'M1', imm1, ' INPUT'
	Write (12, 18) 'M1', imm1, ' INPUT-F'
	Write (12, 18) 'M1', imm1, ' INPUT_COSMO'
	Write (12, 18) 'M1', imm1, ' cosmo-grads.gs'

	Write (12, 18) 'M2', imm2, ' INPUT'
	Write (12, 18) 'M2', imm2, ' INPUT-F'
	Write (12, 18) 'M2', imm2, ' INPUT_COSMO'
	Write (12, 18) 'M2', imm2, ' cosmo-grads.gs'

	Write (12, 18) 'HH', ihh, ' INPUT'
	Write (12, 18) 'HH', ihh, ' INPUT-F'
	Write (12, 18) 'HH', ihh, ' INPUT_COSMO'
	Write (12, 18) 'HH', ihh, ' cosmo-grads.gs'
 18	Format (10x, 'replace-string ', a2, 1x, i2.2, a20)

 	Write (12, 19) 'H+00', khh(ikhh+3), 'cosmo-grads.gs'
 	Write (12, 19) 'H+06', khh(ikhh+0), 'cosmo-grads.gs'
 	Write (12, 19) 'H+12', khh(ikhh+1), 'cosmo-grads.gs'
 	Write (12, 19) 'H+18', khh(ikhh+2), 'cosmo-grads.gs'
 	Write (12, 19) 'H+24', khh(ikhh+3), 'cosmo-grads.gs'
 19	Format (10x, 'replace-string ', 1x, a4, 1x, i2.2, 1x, a20)

	Write (12, 20) cmon1(imm1), iyyyy1, idd1, ihh
 20	Format (10x,'mkdir -p ~/DBS-COSMO/OUTPUT/',a3,i4.4,'/',i2.2,'-', i2.2)

        Write (12, 21) cmon1(imm1), iyyyy1, idd1, ihh,                  &
                       cmon1(imm1), iyyyy1, idd1, ihh
 21     Format (                                                        &
        /, 10x, 'mv * ~/DBS-COSMO/OUTPUT/',a3, i4.4,'/', i2.2,'-',i2.2,  &
        /, 10x, 'cd ~/DBS-COSMO/OUTPUT/', a3, i4.4, '/', i2.2, '-', i2.2,&
        /, 10x, 'mpirun -np 16 ~/DBS-COSMO/bin/INT2LM-LATEST',        &
        /, 10x, 'make-link',                                             &
        /, 10x, 'mpirun -np 16 ~/DBS-COSMO/bin/COSMO-LATEST',            &
        /, 10x, 'gme2ctl.pl -a lf*0',                                 &
        /, 10x, 'gme2ctl.pl -a lf*0p',                                   &
        /, 10x, 'gme2ctl.pl -a lf*0z',                                   &
        /, 10x, 'grads -pbc "run cosmo-grads.gs" ',                      &
        /, 10x, 'read-dol-300m-winds.x',                                 &
        /, 10x, 'enscript -L 52 -o DOL-300m-winds.ps DOL-300m-winds.txt',&
        /, 10x, 'makepdf-files.shar')

        Write (12, 22) idd2, cmon1(imm2), iyyyy2, ihh,                  &
                       idd2, cmon1(imm2), iyyyy2, ihh,                  &
                       idd2, cmon1(imm2), iyyyy2, ihh,                  &
                       idd2, cmon1(imm2), iyyyy2, ihh,                  &
                       idd2, cmon1(imm2), iyyyy2, ihh,                  &
                       idd2, cmon1(imm2), iyyyy2, ihh,                  &
                       idd2, cmon1(imm2), iyyyy2, ihh,                  &
                       idd2, cmon1(imm2), iyyyy2, ihh,                  &
		       iyyyy2, imm2, idd2, ihh
 22     Format (10x, 'mv M_SHAR M-SHAR-', i2.2, a3, i4.4, '-', i2.2,     &
        /, 10x, 'mv M_TVM M-TVM-', i2.2, a3, i4.4, '-', i2.2,            &
        /, 10x, 'mv M_BNG M-BNG-', i2.2, a3, i4.4, '-', i2.2,            &
        /, 10x, 'mv M_CHN M-CHN-', i2.2, a3, i4.4, '-', i2.2,            &
        /, 10x, 'mv M_CHD M-CHD-', i2.2, a3, i4.4, '-', i2.2,           &
        /, 10x, 'mv M_COK M-COK-', i2.2, a3, i4.4, '-', i2.2,           &
        /, 10x, 'mv M_GAD M-GAD-', i2.2, a3, i4.4, '-', i2.2,           &
        /, 10x, 'mv DOL-300m-winds.txt DOL-', i2.2, a3, i4.4, '-', i2.2, '.txt',&
        /, 10x, 'mv COSMO.pdf SPL-COSMO-', i4.4, 3('-', i2.2),'.pdf',    &
        /, 10x, '#cp *.pdf ~/DBS-COSMO/Archival-Forecasts',               &
        /, 10x, '#cp M-* ~/DBS-COSMO/Archival-Forecasts',                 &
        /, 10x, '#cp CHD*.txt ~/DBS-COSMO/Archival-Forecasts',            &
        /, 10x, 'rm -f *.ps ig* l* Y* O*')

        Stop

        End

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!i!!!!!!!!!!!!!!!!!!!!!!!!!
!!! Smbroutine for inter-conversion of Calendar and Julian Days      !!!
!!! Forward Conversion: Calendar Day to Julian Day                   !!!
!!! Reverse Conversion: Julian Day to Calendar Day                   !!!
!!! Version: April 05, 2010 (ATJ/DBS)                                !!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

	! idd	= date 	(Can be anything between 1 to 31)
	! imo	= month (Can be anything between 1 to 12)
	! iyr	= year 	(Can be literally anything)
	! jday	= julian day number (Can be anything between 1 to 366)
	! iflag = 1 for forward; -1 for reverse

	Subroutine cal_jul_cal (iddd,immm,iyyy,julday,iflag)
	
       	Dimension incmon(13), leapinc(13)

       	Data incmon /0, 31, 59, 90, 120, 151, 181, 212, &
     &			  243, 273, 304, 334, 365/

       	Data leapinc /0, 31, 60, 91, 121, 152, 182, 213,&
     &			  244, 274, 305, 335, 366/

       	icheck = mod (iyyy, 4) ! icheck is leap year checking index
!*		icheck = 0, if the current year is not a leap year
!*		icheck = 1, if the current year is a leap year

	If (iflag ==  1) Go to 101
	If (iflag == -1) Go to 102

 101	Continue

       	If (icheck /= 0) julday = iddd + incmon(immm)
       	If (icheck == 0) julday = iddd + leapinc(immm)

	Go to 110

 102	Continue

	If (icheck /= 0) then

       	Do i = 1, 12

       	j = i + 1

       	if ( (julday > incmon(i)).and.(julday <= incmon(j)) ) &
     &		  immm = i
       	if ( (julday > incmon(i)).and.(julday <= incmon(j)) ) & 
     &  	  iddd = julday-incmon(i)
  
       	Enddo    
        
       	Else
        
       	Do i = 1, 12

       	j = i + 1

       	if ( (julday > leapinc(i)).and.(julday <= leapinc(j)) ) &
     &		      immm = i
       	if ( (julday > leapinc(i)).and.(julday <= leapinc(j)) )  &
     &		      iddd = julday-leapinc(i)

	Enddo    

	Endif

	Go to 110

 110	Return

       	End
